## binutils-avr 2.26.20160125+Atmel3.7.0

=== binutils/zlib/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.4.4)
set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS ON)

project(zlib C)

set(VERSION "1.2.7")

set(INSTALL_BIN_DIR "${CMAKE_INSTALL_PREFIX}/bin" CACHE PATH "Installation directory for executables")
set(INSTALL_LIB_DIR "${CMAKE_INSTALL_PREFIX}/lib" CACHE PATH "Installation directory for libraries")
set(INSTALL_INC_DIR "${CMAKE_INSTALL_PREFIX}/include" CACHE PATH "Installation directory for headers")
set(INSTALL_MAN_DIR "${CMAKE_INSTALL_PREFIX}/share/man" CACHE PATH "Installation directory for manual pages")
set(INSTALL_PKGCONFIG_DIR "${CMAKE_INSTALL_PREFIX}/share/pkgconfig" CACHE PATH "Installation directory for pkgconfig (.pc) files")

include(CheckTypeSize)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckCSourceCompiles)
enable_testing()

check_include_file(sys/types.h HAVE_SYS_TYPES_H)
check_include_file(stdint.h    HAVE_STDINT_H)
check_include_file(stddef.h    HAVE_STDDEF_H)

#
# Check to see if we have large file support
#
set(CMAKE_REQUIRED_DEFINITIONS -D_LARGEFILE64_SOURCE=1)
# We add these other definitions here because CheckTypeSize.cmake
# in CMake 2.4.x does not automatically do so and we want
# compatibility with CMake 2.4.x.
if(HAVE_SYS_TYPES_H)
    list(APPEND CMAKE_REQUIRED_DEFINITIONS -DHAVE_SYS_TYPES_H)
endif()
if(HAVE_STDINT_H)
    list(APPEND CMAKE_REQUIRED_DEFINITIONS -DHAVE_STDINT_H)
endif()
if(HAVE_STDDEF_H)
    list(APPEND CMAKE_REQUIRED_DEFINITIONS -DHAVE_STDDEF_H)
endif()
check_type_size(off64_t OFF64_T)
if(HAVE_OFF64_T)
   add_definitions(-D_LARGEFILE64_SOURCE=1)
endif()
set(CMAKE_REQUIRED_DEFINITIONS) # clear variable

#
# Check for fseeko
#
check_function_exists(fseeko HAVE_FSEEKO)
if(NOT HAVE_FSEEKO)
    add_definitions(-DNO_FSEEKO)
endif()

#
# Check for unistd.h
#
check_include_file(unistd.h Z_HAVE_UNISTD_H)

if(MSVC)
    set(CMAKE_DEBUG_POSTFIX "d")
    add_definitions(-D_CRT_SECURE_NO_DEPRECATE)
    add_definitions(-D_CRT_NONSTDC_NO_DEPRECATE)
    include_directories(${CMAKE_CURRENT_SOURCE_DIR})
endif()

if(NOT CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_CURRENT_BINARY_DIR)
    # If we're doing an out of source build and the user has a zconf.h
    # in their source tree...
    if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/zconf.h)
        message(STATUS "Renaming")
        message(STATUS "    ${CMAKE_CURRENT_SOURCE_DIR}/zconf.h")
        message(STATUS "to 'zconf.h.included' because this file is included with zlib")
        message(STATUS "but CMake generates it automatically in the build directory.")
        file(RENAME ${CMAKE_CURRENT_SOURCE_DIR}/zconf.h ${CMAKE_CURRENT_SOURCE_DIR}/zconf.h.included)
  endif()
endif()

set(ZLIB_PC ${CMAKE_CURRENT_BINARY_DIR}/zlib.pc)
configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/zlib.pc.cmakein
		${ZLIB_PC} @ONLY)
configure_file(	${CMAKE_CURRENT_SOURCE_DIR}/zconf.h.cmakein
		${CMAKE_CURRENT_BINARY_DIR}/zconf.h @ONLY)
include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_SOURCE_DIR})


#============================================================================
# zlib
#============================================================================

set(ZLIB_PUBLIC_HDRS
    ${CMAKE_CURRENT_BINARY_DIR}/zconf.h
    zlib.h
)
set(ZLIB_PRIVATE_HDRS
    crc32.h
    deflate.h
    gzguts.h
    inffast.h
    inffixed.h
    inflate.h
    inftrees.h
    trees.h
    zutil.h
)
set(ZLIB_SRCS
    adler32.c
    compress.c
    crc32.c
    deflate.c
    gzclose.c
    gzlib.c
    gzread.c
    gzwrite.c
    inflate.c
    infback.c
    inftrees.c
    inffast.c
    trees.c
    uncompr.c
    zutil.c
)

if(NOT MINGW)
    set(ZLIB_SRCS ${ZLIB_SRCS}
        win32/zlib1.rc # If present will override custom build rule below.
    )
endif()

# parse the full version number from zlib.h and include in ZLIB_FULL_VERSION
file(READ ${CMAKE_CURRENT_SOURCE_DIR}/zlib.h _zlib_h_contents)
string(REGEX REPLACE ".*#define[ \t]+ZLIB_VERSION[ \t]+\"([-0-9A-Za-z.]+)\".*"
    "\\1" ZLIB_FULL_VERSION ${_zlib_h_contents})

if(MINGW)
    # This gets us DLL resource information when compiling on MinGW.
    if(NOT CMAKE_RC_COMPILER)
        SET(CMAKE_RC_COMPILER windres.exe)
    endif()

    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/zlib1rc.obj
                       COMMAND ${CMAKE_RC_COMPILER}
                            -D GCC_WINDRES
                            -I ${CMAKE_CURRENT_SOURCE_DIR}
                            -I ${CMAKE_CURRENT_BINARY_DIR}
                            -o ${CMAKE_CURRENT_BINARY_DIR}/zlib1rc.obj
                            -i ${CMAKE_CURRENT_SOURCE_DIR}/win32/zlib1.rc)
    set(ZLIB_SRCS ${ZLIB_SRCS} ${CMAKE_CURRENT_BINARY_DIR}/zlib1rc.obj)
endif(MINGW)

add_library(zlib SHARED ${ZLIB_SRCS} ${ZLIB_PUBLIC_HDRS} ${ZLIB_PRIVATE_HDRS})
add_library(zlibstatic STATIC ${ZLIB_SRCS} ${ZLIB_PUBLIC_HDRS} ${ZLIB_PRIVATE_HDRS})
set_target_properties(zlib PROPERTIES DEFINE_SYMBOL ZLIB_DLL)
set_target_properties(zlib PROPERTIES SOVERSION 1)

if(NOT CYGWIN)
    # This property causes shared libraries on Linux to have the full version
    # encoded into their final filename.  We disable this on Cygwin because
    # it causes cygz-${ZLIB_FULL_VERSION}.dll to be created when cygz.dll
    # seems to be the default.
    #
    # This has no effect with MSVC, on that platform the version info for
    # the DLL comes from the resource file win32/zlib1.rc
    set_target_properties(zlib PROPERTIES VERSION ${ZLIB_FULL_VERSION})
endif()

if(UNIX)
    # On unix-like platforms the library is almost always called libz
   set_target_properties(zlib zlibstatic PROPERTIES OUTPUT_NAME z)
   set_target_properties(zlib PROPERTIES LINK_FLAGS "-Wl,--version-script,${CMAKE_CURRENT_SOURCE_DIR}/zlib.map")
elseif(BUILD_SHARED_LIBS AND WIN32)
    # Creates zlib1.dll when building shared library version
    set_target_properties(zlib PROPERTIES SUFFIX "1.dll")
endif()

if(NOT SKIP_INSTALL_LIBRARIES AND NOT SKIP_INSTALL_ALL )
    install(TARGETS zlib zlibstatic
        RUNTIME DESTINATION "${INSTALL_BIN_DIR}"
        ARCHIVE DESTINATION "${INSTALL_LIB_DIR}"
        LIBRARY DESTINATION "${INSTALL_LIB_DIR}" )
endif()
if(NOT SKIP_INSTALL_HEADERS AND NOT SKIP_INSTALL_ALL )
    install(FILES ${ZLIB_PUBLIC_HDRS} DESTINATION "${INSTALL_INC_DIR}")
endif()
if(NOT SKIP_INSTALL_FILES AND NOT SKIP_INSTALL_ALL )
    install(FILES zlib.3 DESTINATION "${INSTALL_MAN_DIR}/man3")
endif()
if(NOT SKIP_INSTALL_FILES AND NOT SKIP_INSTALL_ALL )
    install(FILES ${ZLIB_PC} DESTINATION "${INSTALL_PKGCONFIG_DIR}")
endif()

#============================================================================
# Example binaries
#============================================================================

add_executable(example test/example.c)
target_link_libraries(example zlib)
add_test(example example)

add_executable(minigzip test/minigzip.c)
target_link_libraries(minigzip zlib)

if(HAVE_OFF64_T)
    add_executable(example64 test/example.c)
    target_link_libraries(example64 zlib)
    set_target_properties(example64 PROPERTIES COMPILE_FLAGS "-D_FILE_OFFSET_BITS=64")
    add_test(example64 example64)

    add_executable(minigzip64 test/minigzip.c)
    target_link_libraries(minigzip64 zlib)
    set_target_properties(minigzip64 PROPERTIES COMPILE_FLAGS "-D_FILE_OFFSET_BITS=64")
endif()

=== debian/changelog ===
binutils-avr (2.26.20160125+Atmel3.7.0-2) unstable; urgency=low

  * debian/patches: Clean up the patches and add another stack smash fix.
  * debian/control: Remove autotools-dev and dh-autoreconf from
                    Build-Depends.
  * debian/rules: Fix some issues found by lintian. Add hardening.

 -- Steve Meliza <swm@swm1.com>  Fri, 27 Oct 2023 17:03:15 -0700

binutils-avr (2.26.20160125+Atmel3.7.0-1) unstable; urgency=low

  * New Maintainer (Closes: #1051390)
  * New upstream release
  * debian/watch: Update path and REGEX
  * debian/copyright: Update to DEP5
  * debian/control: Increase Standards-Version to 4.6.2

  [Max A. Dednev]
  * Stack smashing patch (Closes: 1006223)

 -- Steve Meliza <swm@swm1.com>  Mon, 16 Oct 2023 19:48:23 -0700

=== debian/control ===
Source: binutils-avr
Section: devel
Priority: optional
Maintainer: Steve Meliza <swm@swm1.com>
Standards-Version: 4.6.2
Homepage: https://www.microchip.com/en-us/tools-resources/develop/microchip-studio/gcc-compilers
Build-Depends: bison, flex, gettext, texinfo, binutils, debhelper-compat (= 13), bzip2, zlib1g-dev
Vcs-Git: https://salsa.debian.org/debian/binutils-avr.git
Vcs-Browser: https://salsa.debian.org/debian/binutils-avr

Package: binutils-avr
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: binutils
Description: Binary utilities supporting Atmel's AVR targets
 The programs in this package are used to manipulate binary and object
 files that may have been created for Atmel's AVR architecture.  This package
 is primarily for AVR developers and cross-compilers and is not needed
 by normal users or developers.

=== debian/watch ===
version=4
opts="dversionmangle=s/2\.26\.20160125\+Atmel//" \
https://www.microchip.com/en-us/tools-resources/develop/microchip-studio/gcc-compilers \
https://ww1.microchip.com/downloads/aemDocuments/documents/DEV/ProductDocuments/SoftwareTools/avr8-gnu-toolchain-(.+)\..+-linux\.any\.x86_64@ARCHIVE_EXT@

## binutils-avr 2.43.1

=== debian/changelog ===
binutils-avr (2.43.1-1) unstable; urgency=low
  * Switch to mainstream binutils (Closes: #855849)
  * Fix fail to build source after build (Closes: #1044001)
  * Switch over to dh sequencer

 -- Steve Meliza <swm@swm1.com>  Sun, 29 Sep 2024 14:32:21 -0700

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,17 @@
 Section: devel
 Priority: optional
 Maintainer: Steve Meliza <swm@swm1.com>
-Standards-Version: 4.6.2
-Homepage: https://www.microchip.com/en-us/tools-resources/develop/microchip-studio/gcc-compilers
-Build-Depends: bison, flex, gettext, texinfo, binutils, debhelper-compat (= 13), bzip2, zlib1g-dev
+Build-Depends: debhelper-compat (= 13),
+               bison,
+               flex,
+               gettext,
+               texinfo,
+               binutils-source (>=2.43.1),
+               bzip2,
+               zlib1g-dev
+Standards-Version: 4.7.0
+Rules-Requires-Root: no
+Homepage: https://www.gnu.org/s/binutils/
 Vcs-Git: https://salsa.debian.org/debian/binutils-avr.git
 Vcs-Browser: https://salsa.debian.org/debian/binutils-avr

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/architecture.mk

PACKAGE=binutils-avr
TARGET=avr
BUILT_USING := $(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W binutils-source)
CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)

#DEB_HOST_GNU_TYPE = $(shell dpkg-architecture -q DEB_HOST_GNU_TYPE)
#DEB_BUILD_GNU_TYPE = $(shell dpkg-architecture -q DEB_BUILD_GNU_TYPE)

CONFARGS = --prefix=/usr \
           --build=$(DEB_BUILD_GNU_TYPE) \
           --host=$(DEB_HOST_GNU_TYPE) \
           --target=$(TARGET) \
           --with-gnu-ld \
           --with-gnu-as \
		   --with-system-zlib \
           --enable-install-libbfd \
           --with-dwarf2 \
           --disable-static \
           --disable-gdb --disable-libdecnumber --disable-readline \
           --disable-sim \
           $(shell env DEB_CFLAGS_MAINT_APPEND="-Wno-implicit-fallthrough -Wno-format-overflow -Wno-pointer-compare -Wno-error=cast-function-type -Wno-error=stringop-truncation -Wno-error=format-truncation" \
		     env DEB_BUILD_MAINT_OPTIONS="hardening=+all" \
		     dpkg-buildflags --export=configure)


# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

#TAR_DIR=binutils-*
#TAR_DIR=TAR_DIR=binutils-*
#include /usr/share/dbs/dbs-build.mk
#include debian/dbs-build.mk

BUILD_TREE=build

%:
	dh $@


override_dh_auto_configure: configure-stamp

unpack-stamp:
	tar xf /usr/src/binutils/binutils-*.tar.*
	mv binutils* src
	patch -p1 src/binutils/size.c debian/size_avr_support.patch
	mkdir build
	touch unpack-stamp

patch-stamp: unpack-stamp
	touch $@

# the dbs rules
#include /usr/src/toolchain/patches/binutils/dbs-build.mk
#
configure-stamp: patch-stamp
	dh_testdir

	dh_update_autotools_config
	# Add here commands to configure the package.
	cd $(BUILD_TREE) && env CC="gcc" CFLAGS="-Wno-error=unused-but-set-variable -Wno-error=unused-but-set-parameter" CPPFLAGS="$(CPPFLAGS)" ../src/configure $(CONFARGS)
	make -C $(BUILD_TREE) maybe-configure-bfd
	make -C $(BUILD_TREE)/bfd/ headers
	touch configure-stamp

override_dh_auto_build:configure-stamp build-stamp

build-stamp:
	dh_testdir

	# Add here commands to compile the package.
	cd $(BUILD_TREE) && $(MAKE)
	#/usr/bin/docbook-to-man debian/$(PACKAGE).sgml > $(PACKAGE).1

	touch build-stamp

override_dh_auto_clean:
	dh_testdir
	dh_testroot
	rm -f configure-stamp unpack-stamp patch-stamp
	rm -f debian/files debian/binuils-avr.substvars
	rm -rf src build debian/binutils-avr debian/.debhelper

override_dh_auto_install:
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	# Add here commands to install the package into debian/$(PACKAGE).
	cd $(BUILD_TREE) && $(MAKE) install prefix=$(CURDIR)/debian/$(PACKAGE)/usr

	# Non standard avr dir to keep FHS happy
	mv debian/binutils-avr/usr/avr debian/binutils-avr/usr/lib/

	# Convert hardlinks to softlinks
	cd debian/binutils-avr/usr/lib/avr/bin && for f in *; do \
	    rm ../../../bin/avr-$$f; \
	    ln -s ../lib/avr/bin/$$f ../../../bin/avr-$$f; \
	done

	# Emptying the dependency_libs field of .la files
	sed -i "/dependency_libs/ s/'.*'/''/" `find debian/binutils-avr -name '*.la'`

	# Adjust paths
	sed -i 's/\/usr\/$(DEB_HOST_GNU_TYPE)\/avr/\/usr\/lib\/avr\/$(DEB_HOST_GNU_TYPE)/' `find debian/binutils-avr -name '*.la'`

	ln -s avr-ld.1.gz debian/binutils-avr/usr/share/man/man1/avr-ld.bfd.1.gz

    # Remove man pages that are not needed
	rm debian/binutils-avr/usr/share/man/man1/avr-dlltool.1
	rm debian/binutils-avr/usr/share/man/man1/avr-windmc.1
	rm debian/binutils-avr/usr/share/man/man1/avr-windres.1

	# Files also in main binutils pkg
	cd debian/$(PACKAGE)/usr && \
	rm -rf include \
	rm -rf lib/libiberty.* lib/libbfd.* lib/libopcodes* \
	include/bfd.h include/ansidecl.h include/bfdlink.h \
	share/locale include/symcat.h include/dis-asm.h \
	info share/info share/man/man1/avr-c++filt.1.gz \
	share/locale

	mv debian/binutils-avr/usr/$(DEB_HOST_GNU_TYPE)/avr \
	   debian/binutils-avr/usr/lib/avr/$(DEB_HOST_GNU_TYPE)
	rm -r debian/binutils-avr/usr/$(DEB_HOST_GNU_TYPE)

	mkdir debian/binutils-avr/usr/lib/avr/lib/

	rm -f debian/binutils-avr/usr/lib/*.a
	rm -f debian/binutils-avr/usr/lib/*.la \
	rm -rf debian/binutils-avr/usr/lib/bfd-plugins

	mv debian/binutils-avr/usr/lib/ldscripts \
	   debian/binutils-avr/usr/lib/avr/lib/ldscripts

## binutils-avr 2.43.50.20241215

=== debian/changelog ===
binutils-avr (2.43.50.20241215-1) unstable; urgency=high

  * d/rules: Turn off new warning causing a FTBFS (Closes: #1090195)

  [Helmut Grohne]
  * d/rules: Don't force the build architecture compiler. (Closes: #1086132)

 -- Steve Meliza <swm@swm1.com>  Thu, 19 Dec 2024 22:04:29 -0800

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                flex,
                gettext,
                texinfo,
-               binutils-source (>=2.43.1),
+               binutils-source (>=2.43.50.20241215),
                bzip2,
                zlib1g-dev
 Standards-Version: 4.7.0

## binutils-avr 2.43.50.20250108

=== debian/changelog ===
binutils-avr (2.43.50.20250108-1) unstable; urgency=high

  * d/size_avr_support.patch: Add casts to fix build error on some archs.

 -- Steve Meliza <swm@swm1.com>  Fri, 24 Jan 2025 17:12:30 -0800

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                flex,
                gettext,
                texinfo,
-               binutils-source (>=2.43.50.20241215),
+               binutils-source (>=2.43.50.20250108),
                bzip2,
                zlib1g-dev
 Standards-Version: 4.7.0

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,8 @@
 #!/usr/bin/make -f
 # Sample debian/rules that uses debhelper.
 # GNU copyright 1997 to 1999 by Joey Hess.
+
+#https://wiki.debian.org/PackagingLessCommonBinutilsTargets
 
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
@@ -26,7 +28,7 @@
            --disable-static \
            --disable-gdb --disable-libdecnumber --disable-readline \
            --disable-sim \
-           $(shell env DEB_CFLAGS_MAINT_APPEND="-Wno-implicit-fallthrough -Wno-format-overflow -Wno-pointer-compare -Wno-error=cast-function-type -Wno-error=stringop-truncation -Wno-error=format-truncation" \
+           $(shell env DEB_CFLAGS_MAINT_APPEND="-Wno-implicit-fallthrough -Wno-format-overflow -Wno-pointer-compare -Wno-error=cast-function-type -Wno-error=stringop-truncation -Wno-error=format-truncation -Wno-error=discarded-qualifiers" \
 		     env DEB_BUILD_MAINT_OPTIONS="hardening=+all" \
 		     dpkg-buildflags --export=configure)
 
@@ -65,7 +67,7 @@
 
 	dh_update_autotools_config
 	# Add here commands to configure the package.
-	cd $(BUILD_TREE) && env CC="gcc" CFLAGS="-Wno-error=unused-but-set-variable -Wno-error=unused-but-set-parameter" CPPFLAGS="$(CPPFLAGS)" ../src/configure $(CONFARGS)
+	cd $(BUILD_TREE) && env CFLAGS="-Wno-error=unused-but-set-variable -Wno-error=unused-but-set-parameter" CPPFLAGS="$(CPPFLAGS)" ../src/configure $(CONFARGS)
 	make -C $(BUILD_TREE) maybe-configure-bfd
 	make -C $(BUILD_TREE)/bfd/ headers
 	touch configure-stamp

=== debian/watch ===
version=4

opts=pgpsigurlmangle=s/$/.sig/ https://ftp.gnu.org/gnu/binutils/binutils-(.*)\.tar\.(?:gz|bz2|xz)
